<template>
  <div class="single-post">
    <div class="post-card">
      <div class="post" v-if="post">
        <h2 class="post-title">{{ post.title }}: {{ post.subtitle }}</h2>
        <div class="post-meta">
          By <AuthorLink :author="post.author" />
          <FollowButton :user="post.author"></FollowButton>
          <div v-if="isFollowing">
            <p>You are following this user.</p>
          </div>
          <div>{{ displayableDate(post.publishDate) }}</div>
        </div>
        <p class="post__description">{{ post.metaDescription }}</p>
        <article class="post-body">{{ post.body }}</article>
        <div class="post-tags">
          <ul>
            <li class="post__tag" v-for="tag in post.tags" :key="tag.name">
              <router-link :to="`/tag/${tag.name}`">#{{ tag.name }}</router-link>
            </li>
          </ul>
        </div>
        <!-- Display likedByUsers and comments -->
        <like-button :liked="postLiked" @toggle-like="toggleLike" />
        <comment-button />
        <div class="post-likes">
          

          Liked by:
          <span v-for="user in post.likedByUsers" :key="user.username">{{ user.username }}</span>
          <span v-if="post.likedByUsers.length === 0">No likes</span>
        </div>
        <div class="post-comments">
          Comments:
          <div v-if="post.comments.length === 0">No comments</div>
          <div v-for="comment in post.comments" :key="comment.text" class="comment">
            <span class="comment__user">{{ comment.user.username }}:</span>
            <span class="comment__text">{{ comment.text }}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
  
  <script>



  import LikeButton from "@/components/blog/LikeButton.vue";
  import CommentButton from "@/components/blog/CommentButton.vue"; 
  import AuthorLink from "@/components/user/AuthorLink";
  import FollowButton from "@/components/blog/FollowButton.vue"; 

  import gql from "graphql-tag";
  
  export default {
    name: "ThePost",
    components: {
      AuthorLink,
      LikeButton,
      CommentButton,
      isFollowing: false,
    },
    data() {
      return {
        post: null,
        postLiked: false, 
        newComment: "", 
        isFollowing: false, 
      };
    },
    methods: {
      displayableDate(date) {
        return new Intl.DateTimeFormat("en-US", { dateStyle: "full" }).format(new Date(date));
      },
      toggleLike() {
      this.postLiked = !this.postLiked;
      // You can also send a GraphQL mutation here to update the backend
    },
    toggleFollow() {
      // Update isFollowing based on user interaction or API call.
      this.isFollowing = !this.isFollowing;
    },
    async addComment() {
    if (this.newComment.trim() === "") {
      return; // Don't add empty comments
    }

    try {
      const response = await this.$apollo.mutate({
        
        variables: {
          post_id: this.post.id,
          text: this.newComment,
        },
        
      });

      // Assuming the mutation returns the added comment
      const addedComment = response.data.addComment.comment;

      // Add the new comment to the post's comments list
      this.post.comments.push(addedComment);

      // Reset the comment input
      this.newComment = "";
    } catch (error) {
      console.error("Error adding comment:", error);
    }
  },
    },

    async created() {
    const post = await this.$apollo.query({
    query: gql`
      query ($slug: String!) {
        postBySlug(slug: $slug) {
          title
          subtitle
          publishDate
          metaDescription
          slug
          body
          author {
            user {
              username
            }
          }
          tags {
            name
          }
          likedByUsers {
            user {
              username
            }
          }
          comments {
            text
            user {
              user {
                username
              }
            }
          }
        }
      }
    `,
    variables: {
      slug: this.$route.params.slug,
    },
  });

  // Update the structure of post data
  this.post = {
    ...post.data.postBySlug,
    likedByUsers: post.data.postBySlug.likedByUsers.map((userObj) => userObj.user),
    comments: post.data.postBySlug.comments.map((comment) => ({
      text: comment.text,
      user: comment.user.user,
    })),
  };
},

  };
  </script>
  

  <style scoped>
.single-post {
  padding: 0 20px; /* Add left and right padding */
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh; /* Center content vertically */
}

.post-card {
  background-color: #ffffff; /* Card background color */
  box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.1); /* 3D card-like shadow */
  padding: 20px; /* Card padding */
  width: 80%; /* Card width */
  max-width: 600px; /* Max card width */
  border-radius: 10px; /* Rounded corners */
}

.post-title {
  font-size: 24px; /* Adjust title font size */
  margin-bottom: 10px; /* Add space below title */
}

.post-meta {
  margin-bottom: 20px; /* Add space below meta */
}

.post__description {
  /* Style the post description as needed */
  margin-bottom: 20px; /* Add space below description */
}

.post-body {
  /* Style the post body as needed */
  line-height: 1.5; /* Adjust line height for readability */
}

.post-tags {
  /* Style the post tags as needed */
  margin-top: 20px; /* Add space above tags */
}

.post-likes {
  /* Style the likedByUsers section as needed */
  margin-top: 20px; /* Add space above likes */
}

.post-comments {
  /* Style the comments section as needed */
  margin-top: 20px; /* Add space above comments */
}

.comment {
  /* Style individual comments as needed */
  margin-top: 10px; /* Add space between comments */
}

.comment__user {
  /* Style the comment user as needed */
  font-weight: bold; /* Make the username bold */
  margin-right: 5px; /* Add space to the right of the username */
}

.comment-input {
  margin-top: 20px; /* Add space above the comment input */
}

textarea {
  width: 100%;
  padding: 5px;
  border: 1px solid #ccc;
  border-radius: 5px;
  margin-bottom: 10px; /* Add space below the input */
}

button {
  background-color: #007bff;
  color: white;
  border: none;
  padding: 5px 10px;
  cursor: pointer;
}
</style>